/*
**   Modification of Fizick's yadif avisynth filter.
**   Copyright (C) 2007 Kevin Stone
**   Yadif C-plugin for Avisynth 2.5 - Yet Another DeInterlacing Filter
**   Copyright (C) 2007 Alexander G. Balakhnin aka Fizick  http://avisynth.org.ru
**   Port of YADIF filter from MPlayer
**   Copyright (C) 2006 Michael Niedermayer <michaelni@gmx.at>
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <windows.h>
#include <stdio.h>
#include "avisynth.h"
#include "PlanarFrame.h"

#define MIN3(a,b,c) min(min(a,b),c)
#define MAX3(a,b,c) max(max(a,b),c)

struct PFC
{
	PlanarFrame *pf;
	int n;
};

class yadifmod : public GenericVideoFilter
{
private:
	PClip edeint;
	VideoInfo vi_saved;
	int order, field, mode, opt;
	PFC **srcPF;
	PlanarFrame *dstPF, *edeintPF;
	void yadifmod::resetFrames(PFC **p, int start, int stop);
	int yadifmod::mapn(int n);
	void yadifmod::filter_MMX(const unsigned char *prev2pp, const unsigned char *prevp,
		const unsigned char *srcpp, const unsigned char *nextp, const unsigned char *next2pp,
		const unsigned char *edeintp, unsigned char *dstp, const int width, const int mode,
		const int pitch, int starty, const int stopy);

public:
	PVideoFrame __stdcall yadifmod::GetFrame(int n, IScriptEnvironment *env);
	yadifmod::yadifmod(PClip _child, int _order, int _field, int _mode, 
		PClip _edeint, int _opt, IScriptEnvironment *env);
	yadifmod::~yadifmod();
};